using System;   
using System.Runtime.InteropServices;
using NVT = NETVSL_Types;


//------------------------------------------------
// Set namespace to produce first part of COM name
//------------------------------------------------

namespace NVTest_Test01
{

  //--------------------------------------------
  // NETVSL Notes: 
  // 1. Be sure to use the ClassInterfaceType.None attribute, otherwise .NET adds
  //    extra reflection members throwing off the class layout expected by the Adapter
  // 2. Name this class NETVSL so that Adapter can ask COM for vslname.NETVSL
  //--------------------------------------------

  [ClassInterface(ClassInterfaceType.None)]    
  public class NETVSL: NETVSL_Types.INETVSL {

    public NETVSL() {

    }

    //----------------------------------------
    public NVT.NETVSL_ResultCodes Load (Int32 InterfaceVersion) {
      return NVT.NETVSL_ResultCodes.SUCCESS;      
    }

    //----------------------------------------
    public int AddonCount {
      get {
        return 1;
      }
    }

    //----------------------------------------
    public NVT.NETVSL_ResultCodes GetAddonInfo ( 
      Int32 SessionId , 
      Int32 AddOnIx , 
      ref String Name , 
      ref NVT.NETVSL_AddOnInfo_Attribs Attribs , 
      ref NVT.NETVSL_AddOnInfo_EnableMask EnableMask , 
      ref NVT.NETVSL_AddOnInfo_InvokeOnMask InvokeOnMask , 
      ref NVT.NETVSL_AddOnInfo_NotifyOnMask NotifyOnMask ) {

      Name = "NVTest_Test01_Addon";

      Attribs      = NVT.NETVSL_AddOnInfo_Attribs.ATTS_ISACTION ;
      EnableMask   = NVT.NETVSL_AddOnInfo_EnableMask.ENABLEALWAYS ;
      InvokeOnMask = NVT.NETVSL_AddOnInfo_InvokeOnMask.INVOKE_DEFAULT ;
      NotifyOnMask = NVT.NETVSL_AddOnInfo_NotifyOnMask.NOTIFY_DEFAULT;

      return NVT.NETVSL_ResultCodes.SUCCESS; 
    }

    //----------------------------------------
    public NVT.NETVSL_ResultCodes IsAddOnEnabled (System.Int32 AddOnIx , System.Int32 SessionId ) {

      return NVT.NETVSL_ResultCodes.L2V_ENABLED;      
    }
  
    //----------------------------------------
    public Int32 PollNextEndSessionMessage (ref Int32 SessionId ) {

      return -1; // -1 to indicate ignore and no more
    }

    //----------------------------------------
    public Int32 PollNextTraceMessage (ref NVT.NETVSL_AdapterMessage MsgType, ref String Text ) {
      return -1; // -1 to indicate ignore and no more
    }

    //----------------------------------------
    public void KillSession ( System.Int32 SessionId ) {

    }

    //----------------------------------------
    public NVT.NETVSL_ResultCodes Run (Int32 AddOnIx , Int32 SessionId , String Args ) {
      return NVT.NETVSL_ResultCodes.SUCCESS;      
    }

    //----------------------------------------
    public NVT.NETVSL_ResultCodes Unload (  ) {
      return NVT.NETVSL_ResultCodes.SUCCESS;      
    }

    //----------------------------------------
    public Int32 Test ( Int32 I ) {
      return I + 7;
    }

    //----------------------------------------
    public void VSLInfo (ref String Descr ) {
      Descr = "Version 1002"; 
    }
	}
}
